# " sendNEC.py "
import esp32
import time
from machine import Pin

rmt=esp32.RMT(${channel}, pin=Pin(${portNo}), clock_div=80, carrier_freq=38000)

IODATA=0xE880  # IOdata customer code
T = 560                 # uSecond
LEADER_HIGH = 8960    # 16T
LEADER_LOW = 4480    #  8T

def bit2time(frame: list, w_code: word) -> list:
    b_mask = 0x0001
    for i in range(16):
        if (w_code & b_mask):
            frame.extend([T, 3 * T])   # bit=1 -> 3T
        else:
            frame.extend([T, T])       # bit=0 -> T
        b_mask <<= 1
    return frame

def gen_frame(customer: word, data: word) -> list:
    p_width = [LEADER_HIGH, LEADER_LOW]
    bit2time(p_width, customer)
    bit2time(p_width, data)
    p_width.extend([T])            # stop
    return p_width

def send_ir(rmt, customer: word, data: word) -> None:
    frame = gen_frame(customer, data)
    rmt.write_pulses(frame, start = 1)
    while not (rmt.wait_done()):
        time.sleep_us(T)

def add_invert(code: byte) -> word:
    return (code + ((0xff^code)<<8))

def send_NEC(rmt, customer: word, code: byte) -> None:
    send_ir(rmt, customer, add_invert(code))

def send_IOdata(code: word) -> None:
    send_NEC(rmt, IODATA, (code>>8))
    wait_ms(43)
    send_NEC(rmt, IODATA, (0xff & code))
